% na akkor most tvitelhzi lesz
clear all
%alapmennyisgek meghatrozsa
%forgatvektorok
a = exp(j*120*pi/180); a2 = a ^2;
%
Sa=50;     %MVA
UaI=10.5;  %kV
UaII=132;   %kV
IaI = Sa/(sqrt(3)*UaI);
IaII = Sa/(sqrt(3)*UaII);
ZaI = UaI^2/Sa;
ZaII = UaII^2/Sa;
% elemek rtkei
%genertor
x1 = 24; Ung = 10.5; Sg=50;
xg1 = j*(x1/100)*(Ung^2/Sg)*(1/ZaI);
xg2 = xg1; xg0 = 0.8 * xg1;
%transzformtor
at = [10.5, 132]; St = 75; eps = 11; tip = 'Yd11';
xt1 = j*(eps/100)*(at(1)^2/St)*(1/ZaI); xt2 = xt1; xt0 = xt1;
%vezetk
L = 40; X1v = 0.42; 
xv1 = j*(L * X1v)/ZaII; xv2 = xv1; xv0 = 2.5 * xv1;
%hlzat
UH = 132; SH = 3000;
xh1 = j*(UH^2/SH)*(1/ZaII); xh2 = xh1; xh0 = xh1;

% forrsok viszonylagos egysgei
eg1 = Ung/UaI; eh1 = UH/UaII;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% a 3F zrlat szmtsai
Ibal = eg1/(xg1 + xt1);
Ijobb= eh1/(xv1 + xh1);

I1_3F = Ibal + Ijobb; I2_3F = 0; I0_3F = 0;

% a hibahely fzisramai
Ia3F = I0_3F + I1_3F + I2_3F;
Ib3F = I0_3F + a2*I1_3F + a*I2_3F;
Ic3F = I0_3F + a*I1_3F + a2*I2_3F;

Ia3Fdim=Ia3F*IaII;
Ib3Fdim=Ib3F*IaII;
Ic3Fdim=Ic3F*IaII;

Ia3Fabsdim=abs(Ia3Fdim);
Ib3Fabsdim=abs(Ib3Fdim);
Ic3Fabsdim=abs(Ic3Fdim);

%a hibahely fzis s vonali feszltsgei

Ua3F =0; Ub3F =0; Uc3F =0;
Uab3F =0; Ubc3F =0; Uca3F =0;

% a V vezetk ramai
Iv1_3F = Ijobb; Iv0_3F = 0; Iv2_3F = 0;

Iva_3F = Iv0_3F + Iv1_3F + Iv2_3F;
Ivb_3F = Iv0_3F + a2*Iv1_3F + a*Iv2_3F;
Ivc_3F = Iv0_3F + a*Iv1_3F + a2*Iv2_3F;

Iva_3Fdim=Iva_3F*IaII;
Ivb_3Fdim=Ivb_3F*IaII;
Ivc_3Fdim=Ivc_3F*IaII;

Iva_3Fabsdim=abs(Iva_3Fdim);
Ivb_3Fabsdim=abs(Ivb_3Fdim);
Ivc_3Fabsdim=abs(Ivc_3Fdim);

% a transzformtor B gyjtsne fel foly fzisramok szmtsa

ItB1_3F = Ibal; ItB0_3F = 0; ItB2_3F = 0;

ItBa_3F = ItB0_3F + ItB1_3F + ItB2_3F;
ItBb_3F = ItB0_3F + a2*ItB1_3F + a*ItB2_3F;
ItBc_3F = ItB0_3F + a*ItB1_3F + a2*ItB2_3F;

ItBa_3Fdim=ItBa_3F*IaII;
ItBb_3Fdim=ItBb_3F*IaII;
ItBc_3Fdim=ItBc_3F*IaII;

ItBa_3Fabsdim=abs(ItBa_3Fdim);
ItBb_3Fabsdim=abs(ItBb_3Fdim);
ItBc_3Fabsdim=abs(ItBc_3Fdim);

%a H gyjtsn fzis s vonali feszltsgei

uH1_3F = eh1 - Ijobb * xh1; uH0_3F = 0; uH2_3F = 0;
uaH_3F = uH0_3F + uH1_3F + uH2_3F;
ubH_3F = uH0_3F + a2*uH1_3F + a*uH2_3F;
ucH_3F = uH0_3F + a*uH1_3F + a2*uH2_3F;

uaH_3Fdim=uaH_3F*UaII;
ubH_3Fdim=ubH_3F*UaII;
ucH_3Fdim=ucH_3F*UaII;

uaH_3Fabsdim=abs(uaH_3Fdim);
ubH_3Fabsdim=abs(ubH_3Fdim);
ucH_3Fabsdim=abs(ucH_3Fdim);

% itt kell vonali fesz is; SI-bl szmtand!

uabH_3Fdim = uaH_3Fdim - ubH_3Fdim;
ubcH_3Fdim = ubH_3Fdim - ucH_3Fdim;
ucaH_3Fdim = ucH_3Fdim - uaH_3Fdim;

uabH_3Fabsdim=abs(uabH_3Fdim);
ubcH_3Fabsdim=abs(ubcH_3Fdim);
ucaH_3Fabsdim=abs(ucaH_3Fdim);

% a genertor llrszben foly fzisramok
% fel kell hasznlni a transzformtor fzistolst, szerencsre pont j
% irnyban trnk t, nagyfeszrl kicsire
%
%az Yd11-es traf fzisforgatsa
forg = exp(j*(-330)*pi/180);

Ig1_3F = forg * Ibal; Ig2_3F = 0; Ig0_3F = 0;
Iga_3F = Ig0_3F + Ig1_3F + Ig2_3F;
Igb_3F = Ig0_3F + a2*Ig1_3F + a*Ig2_3F;
Igc_3F = Ig0_3F + a*Ig1_3F + a2*Ig2_3F;

Iga_3Fdim=Iga_3F*IaI;
Igb_3Fdim=Igb_3F*IaI;
Igc_3Fdim=Igc_3F*IaI;

Iga_3Fabsdim=abs(Iga_3Fdim);
Igb_3Fabsdim=abs(Igb_3Fdim);
Igc_3Fabsdim=abs(Igc_3Fdim);

%az A gyjtsn feszltsgei
%
%forgats nlkl:
uA1_3Ffn = eg1 - Ibal * xg1; uA0_3F = 0; uA2_3F = 0;
%forgatssal
uA1_3F = uA1_3Ffn * forg;

%fzisfeszltsgek
uaA_3F = uA0_3F + uA1_3F + uA2_3F;
ubA_3F = uA0_3F + a2*uA1_3F + a*uA2_3F;
ucA_3F = uA0_3F + a*uA1_3F + a2*uA2_3F;

uaA_3Fdim=uaA_3F*UaI;
ubA_3Fdim=ubA_3F*UaI;
ucA_3Fdim=ucA_3F*UaI;

uaA_3Fabsdim=abs(uaA_3Fdim);
ubA_3Fabsdim=abs(ubA_3Fdim);
ucA_3Fabsdim=abs(ucA_3Fdim);

%vonali feszltsgek
%
%SI - bl

uabA_3Fdim = uaA_3Fdim - ubA_3Fdim;
ubcA_3Fdim = ubA_3Fdim - ucA_3Fdim;
ucaA_3Fdim = ucA_3Fdim - uaA_3Fdim;

uabA_3Fabsdim=abs(uabA_3Fdim);
ubcA_3Fabsdim=abs(ubcA_3Fdim);
ucaA_3Fabsdim=abs(ucaA_3Fdim);

%==========================================================================
% 2F zrlat

% %szmts Thevenin kppel:
% %prhuzamos g eredje:
% xp_eredo = replus(xt2 + xg2, xv2 + xh2);
% xthev_eredo = replus(xg1 + xt1, xv1 + xh1);
% i_thevenin_eredo = eh1/(xthev_eredo + xp_eredo);
% 
% hasznljunk szuperpozit
% a genertor fell foly ramok:
i1_gen = eg1/(xg1 + xt1 + xg2 + xt2);
% halozat felol foly ram:
i1_halo = eh1/(xh1 + xv1 + xv2 + xh2);
% elvileg akkor az ered:
i1_eredo = i1_gen + i1_halo;
% itt most rlnk hogy ugyanaz az eredmny jtt ki, mint az elznl


% a., feladat megoldsa:
i1_2F = i1_eredo; i2_2F = -1*i1_2F; i0_2F = 0;

% a fzisramok:
Ia2F = i0_2F + i1_2F    +i2_2F;
Ib2F = i0_2F + a2*i1_2F +a*i2_2F;
Ic2F = i0_2F + a*i1_2F  +a2*i2_2F;

Ia2Fdim=Ia2F*IaII;
Ib2Fdim=Ib2F*IaII;
Ic2Fdim=Ic2F*IaII;

Ia2Fabsdim=abs(Ia2Fdim);
Ib2Fabsdim=abs(Ib2Fdim);
Ic2Fabsdim=abs(Ic2Fdim);

% b., feladat:
% sorrendi feszltsgek:
u1_2F = eg1 - i1_gen * (xg1 + xt1);
u2_2F = u1_2F; %mivel prhuzamosan van kapcsolva, s ugyanannak a fesznek kell ott lennie
u0_2F = 0;

% a hibahely fzisfeszltsgei
Ua2F = u0_2F + u1_2F + u2_2F;
Ub2F = u0_2F + a2*u1_2F + a*u2_2F;
Uc2F = u0_2F + a*u1_2F + a2*u2_2F;

Ua2Fdim=Ua2F*UaII;
Ub2Fdim=Ub2F*UaII;
Uc2Fdim=Uc2F*UaII;

Ua2Fabsdim=abs(Ua2Fdim);
Ub2Fabsdim=abs(Ub2Fdim);
Uc2Fabsdim=abs(Uc2Fdim);

% vonali feszltsgeket SI-bl kiszmtom

Uab2Fdim = Ua2Fdim - Ub2Fdim;
Ubc2Fdim = Ub2Fdim - Uc2Fdim;
Uca2Fdim = Uc2Fdim - Ua2Fdim;

Uab2Fabsdim=abs(Uab2Fdim);
Ubc2Fabsdim=abs(Ubc2Fdim);
Uca2Fabsdim=abs(Uca2Fdim);

% c., a vezetken foly fzisramok

% sorrendi ramsszetevk:
% a szuperpozcis mdszerbl addik, a theveninesbl ramosztssal jn ki
i2_halo = -i1_halo; i0_halo = 0;

% a hlzat fell foly fzisramok:
Ia_halo_2F = i0_halo + i1_halo + i2_halo;
Ib_halo_2F = i0_halo + a2*i1_halo + a*i2_halo;
Ic_halo_2F = i0_halo + a*i1_halo + a2*i2_halo;

Ia_halo_2Fdim=Ia_halo_2F*IaII;
Ib_halo_2Fdim=Ib_halo_2F*IaII;
Ic_halo_2Fdim=Ic_halo_2F*IaII;

Ia_halo_2Fabsdim=abs(Ia_halo_2Fdim);
Ib_halo_2Fabsdim=abs(Ib_halo_2Fdim);
Ic_halo_2Fabsdim=abs(Ic_halo_2Fdim);

% d., feladat:
% a B gyjtsn fel foly fzisramok:
% a szuperpozcis mdszerbl:
i0_gen = 0; i2_gen = -i1_gen; % a hlzati szimmetria miatt

% a fzisramok:
Ia_gen_2F = i0_gen + i1_gen + i2_gen;
Ib_gen_2F = i0_gen + a2*i1_gen + a*i2_gen;
Ic_gen_2F = i0_gen + a*i1_gen + a2*i2_gen;

Ia_gen_2Fdim=Ia_gen_2F*IaII;
Ib_gen_2Fdim=Ib_gen_2F*IaII;
Ic_gen_2Fdim=Ic_gen_2F*IaII;

% e., a H gyjtsn feszltsgei:
% kiinduls: ismertek a hibahely sorrendi feszltsgei

uH1_2F = u1_2F + i1_halo * xv1;
uH2_2F = u2_2F + i2_halo * xv2;
uH0_2F = 0;

% a fzisfeszltsgek:

UaH_2F = uH0_2F + uH1_2F + uH2_2F;
UbH_2F = uH0_2F + a2*uH1_2F + a*uH2_2F;
UcH_2F = uH0_2F + a*uH1_2F + a2*uH2_2F;

UaH_2Fdim=UaH_2F*UaII;
UbH_2Fdim=UbH_2F*UaII;
UcH_2Fdim=UcH_2F*UaII;

UaH_2Fabsdim=abs(UaH_2Fdim);
UbH_2Fabsdim=abs(UbH_2Fdim);
UcH_2Fabsdim=abs(UcH_2Fdim);

% VONALI IS KELL!!!!!!!!!!!!!!!!!!!!!!

UabH_2Fdim = UaH_2Fdim - UbH_2Fdim;
UbcH_2Fdim = UbH_2Fdim - UcH_2Fdim;
UcaH_2Fdim = UcH_2Fdim - UaH_2Fdim;

UabH_2Fabsdim=abs(UabH_2Fdim);
UbcH_2Fabsdim=abs(UbcH_2Fdim);
UcaH_2Fabsdim=abs(UcaH_2Fdim);

% f., genertor llrszben foly fzisramok:

% t kell forgatni, mert a traf tloldaln van!!!!!

iA1_gen = forg * i1_gen; iA2_gen = conj(forg) * i2_gen; iA0_gen = 0;

IAa_2F = iA0_gen + iA1_gen      + iA2_gen;
IAb_2F = iA0_gen + a2 * iA1_gen + a  * iA2_gen;
IAc_2F = iA0_gen + a  * iA1_gen + a2 * iA2_gen;

IAa_2Fdim=IAa_2F*IaI;
IAb_2Fdim=IAb_2F*IaI;
IAc_2Fdim=IAc_2F*IaI;


% g., az A gyjtsn fzis s vonali feszltsgei:

% elszr fesz kiszmts, utna forgats:
uA0_2Fn = 0;
uA1_2Fn = u1_2F + i1_gen * xt1;
uA2_2Fn = u2_2F + i2_gen * xt2;

uA0_2F = 0;
uA1_2F = forg * uA1_2Fn;
uA2_2F = conj(forg) * uA2_2Fn;

% fzismennyisgek:
UAa_2F = uA0_2F + uA1_2F      +      uA2_2F;
UAb_2F = uA0_2F + a2 * uA1_2F + a  * uA2_2F;
UAc_2F = uA0_2F + a  * uA1_2F + a2 * uA2_2F;

UAa_2Fdim=UAa_2F*UaI;
UAb_2Fdim=UAb_2F*UaI;
UAc_2Fdim=UAc_2F*UaI;

UAa_2Fabsdim=abs(UAa_2Fdim);
UAb_2Fabsdim=abs(UAb_2Fdim);
UAc_2Fabsdim=abs(UAc_2Fdim);

% VONALI IS KELL!!!!!!!!!!!!!!!!!!!!!!

UAab_2Fdim = UAa_2Fdim - UAb_2Fdim;
UAbc_2Fdim = UAb_2Fdim - UAc_2Fdim;
UAca_2Fdim = UAc_2Fdim - UAa_2Fdim;

UAab_2Fabsdim=abs(UAab_2Fdim);
UAbc_2Fabsdim=abs(UAbc_2Fdim);
UAca_2Fabsdim=abs(UAca_2Fdim);

